# This is a BitKeeper generated diff -Nru style patch.
#
# ChangeSet
#   2005/03/25 12:03:15-05:00 len.brown@intel.com 
#   [ACPI] PNPACPI parse error
#   
#   http://bugzilla.kernel.org/show_bug.cgi?id=3912
#   
#   Written-by: matthieu castet <castet.matthieu@free.fr>
#   Acked-by: Shaohua Li <shaohua.li@intel.com>
#   Signed-off-by: Len Brown <len.brown@intel.com>
# 
# drivers/pnp/pnpacpi/rsparser.c
#   2005/03/25 11:20:41-05:00 len.brown@intel.com +10 -1
#   [ACPI] PNPACPI parse error
#   
#   http://bugzilla.kernel.org/show_bug.cgi?id=3912
#   
#   Written-by: matthieu castet <castet.matthieu@free.fr>
#   Acked-by: Shaohua Li <shaohua.li@intel.com>
#   Signed-off-by: Len Brown <len.brown@intel.com>
# 
diff -Nru a/drivers/pnp/pnpacpi/rsparser.c b/drivers/pnp/pnpacpi/rsparser.c
--- a/drivers/pnp/pnpacpi/rsparser.c	2005-07-09 17:35:59 -04:00
+++ b/drivers/pnp/pnpacpi/rsparser.c	2005-07-09 17:35:59 -04:00
@@ -444,6 +444,7 @@
 
 struct acpipnp_parse_option_s {
 	struct pnp_option *option;
+	struct pnp_option *option_independent;
 	struct pnp_dev *dev;
 };
 
@@ -507,7 +508,14 @@
 			parse_data->option = option;	
 			break;
 		case ACPI_RSTYPE_END_DPF:
-			return AE_CTRL_TERMINATE;
+			/*only one EndDependentFn is allowed*/
+			if (!parse_data->option_independent) {
+				pnp_warn("PnPACPI: more than one EndDependentFn");
+				return AE_ERROR;
+			}
+			parse_data->option = parse_data->option_independent;
+			parse_data->option_independent = NULL;
+			break;
 		default:
 			pnp_warn("PnPACPI: unknown resource type %d", res->id);
 			return AE_ERROR;
@@ -525,6 +533,7 @@
 	parse_data.option = pnp_register_independent_option(dev);
 	if (!parse_data.option)
 		return AE_ERROR;
+	parse_data.option_independent = parse_data.option;
 	parse_data.dev = dev;
 	status = acpi_walk_resources(handle, METHOD_NAME__PRS, 
 		pnpacpi_option_resource, &parse_data);
